
/******************************************************************************
                              Include files
******************************************************************************/

#include <\Optc\Include\types.h>
#include <\Optc\Include\stat.h>
#include <io.h>
#include <stdio.h>
#include <stdlib.h>
#include <dos.h>

/******************************************************************************
                                Data Area
******************************************************************************/

static int  file_date;
static char date_string[9];
static char tmp[512];
static char *file_spec =                  /* where to start masacre        */
   "\\*.*";


/******************************************************************************
                            Main program entry
******************************************************************************/




void format_date(date)
int date;
{
    char month,day,year;
    char temp[9];
    char *ptr;
    char c;

    printf("\n\nData In = %d\n\n",date);
    day = date & 0xF;   /* Get Day */
    date = date >> 5;
    month = date & 0xF;
    year = (date >> 4) + 80;
    sprintf(temp,"%2d/%2d/%2d",month,day,year);
    ptr = temp;
    while (*ptr)
    {
        if (*ptr == ' ') *ptr = '0';
        ptr++;
    }
    strcpy(date_string,temp);

}



main(argc,argv)
int   argc;
char *argv[];
{
   int today;

   if (argc = 0){
      printf("Missing filename for ISToday.EXE\n");
      exit(1);
    }

   if (argc > 1){
     strcpy(file_spec,argv[1]);
     strupr(file_spec);
    }
   findall(file_spec);
   today = get_date();
   if (file_date < today)
   {
       format_date(today);
       printf("[%s] ",date_string);
       format_date(file_date);
       printf(" Last Maintenance was %d days ago on %s\n",
                            today - file_date,date_string);
       exit(5);
    }
  exit(0);
}


int get_date()
{
union REGS inregs;
union REGS outregs;
   int temp;

   inregs.h.ah = 42;              /* hex 2A - What is the date? */
   int86(0x21,&inregs,&outregs);  /* interrupt 21               */      
   temp  = outregs.h.dl;                 /* day - 1 to 31            */
   temp |= outregs.h.dh << 5;            /* month - 1 to 12          */
   temp |= (outregs.x.cx - 1980) << 9;            /* year - 1980 to 2099      */
   return(temp);
}



/******************************************************************************
                    Recursive routine to search disk
******************************************************************************/

static findall(path)
char *path;
{
  int status;
  char drive[10],dir[80],name[10],ext[10];
  struct find_t find;
  int mask;

  mask = _A_SUBDIR | _A_NORMAL | _A_RDONLY | _A_HIDDEN | _A_SYSTEM;
  status = _dos_findfirst(path,mask,&find);

  if (!status)
  {
     file_date = find.wr_date;
/*
     format_date(find.wr_date);
     printf("\ndate = %s\n",date_string);
     */
  }
}

